<template>
    <div>
        <main>
            <section class="section section-shaped section-lg">
                <div class="shape shape-style-1 bg-gradient-default">
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                    <span></span>
                </div>
                <div class="container pt-lg-md">
                    <div class="row justify-content-center">
                        <div class="col-lg-5">
                            <div class="card bg-secondary shadow border-0">
                                <div class="card-body px-lg-5 py-lg-5">
                                    <div class="text-center text-muted mb-4">
                                        <h1 class="text-center mb-4">Sign up</h1>
                                    </div>
                                    <form role="form">
                                        <div class="form-group" :class="{'has-danger': !form.email.valid || $v.form.email.$error}">
                                            <div class="input-group input-group-alternative mb-3">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text"><i class="ni ni-email-83"></i></span>
                                                </div>
                                                <input class="form-control" :class="{'is-invalid': !form.email.valid || $v.form.email.$error}" v-model.trim="$v.form.email.val.$model" name="email" placeholder="Email" type="email">
                                            </div>
                                            <div class="alert alert-danger alert-dismissible fade show" v-if="!$v.form.email.val.required && $v.form.email.$error" role="alert">
                                                <span class="alert-inner--text">Field is required</span>
                                            </div>
                                            <div class="alert alert-danger alert-dismissible fade show" v-if="!$v.form.email.val.email && $v.form.email.$error" role="alert">
                                                <span class="alert-inner--text">Field has to be a valid Email</span>
                                            </div>
                                            <div class="alert alert-danger alert-dismissible fade show" v-if="!form.email.valid" role="alert">
                                                <span class="alert-inner--text">{{ form.email.msg }}</span>
                                            </div>
                                        </div>
                                        <div class="form-group" :class="{'has-danger': !form.password.valid || $v.form.password.$error}">
                                            <div class="input-group input-group-alternative">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text"><i class="ni ni-lock-circle-open"></i></span>
                                                </div>
                                                <input class="form-control" :class="{'is-invalid': !form.password.valid || $v.form.password.$error}" v-model.trim="$v.form.password.val.$model" name="password" placeholder="Password" type="password">
                                            </div>
                                            <div class="alert alert-danger alert-dismissible fade show" v-if="!$v.form.password.val.required && $v.form.password.$error" role="alert">
                                                <span class="alert-inner--text">Field is required</span>
                                            </div>
                                            <div class="alert alert-danger alert-dismissible fade show" v-if="!form.password.valid" role="alert">
                                                <span class="alert-inner--text">{{ form.password.msg }}</span>
                                            </div>
                                        </div>
                                        <!-- div class="row my-4">
                                            <div class="col-12">
                                                <div class="custom-control custom-control-alternative custom-checkbox">
                                                    <input class="custom-control-input" id="customCheckRegister" type="checkbox">
                                                    <label class="custom-control-label" for="customCheckRegister"><span>I agree with the <a href="#">Privacy Policy</a></span></label>
                                                </div>
                                            </div>
                                        </div -->
                                        <div class="text-center mb-4">
                                            <button v-if="!form.loading" id="registerSubmit" @click="signup" type="button" class="btn btn-primary mt-4">Create account</button>
                                            <fingerprint-spinner
                                                    v-else
                                                    :animation-duration="1500"
                                                    :size="64"
                                                    color="#5e72e4"
                                                    style="width: 100%"
                                            />
                                        </div>
                                        <div v-if="form.sent && form.success" class="alert alert-success" role="alert">
                                            <strong>Successfully </strong>signed up!
                                        </div>
                                    </form>
                                </div>
                            </div>
                            <div class="row mt-3">
                                <div class="col-12 text-right">
                                    <nuxt-link class="text-light" to="/authentication/login"><small>Already a account ?</small></nuxt-link>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
        </main>
    </div>
</template>
<script>
    import {FingerprintSpinner} from 'epic-spinners'
    import { required, email } from 'vuelidate/lib/validators'
    import Vue from 'vue'
    export default {
        middleware: 'auth',
        auth: 'guest',
        components: {
            FingerprintSpinner
        },
        data() {
            return {
                form: {
                    loading: false,
                    email: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    password: {
                        val: '',
                            msg: '',
                        valid: true
                    },
                    success: false,
                    sent: false
                }
            }
        },
        validations: {
            form: {
                email: {
                    val: {
                        required,
                        email
                    }
                },
                password: {
                    val: {
                        required
                    }
                }
            }
        },
        methods: {
            async signup() {
                this.$v.form.$touch();
                // if its still pending or an error is returned do not submit
                if (this.$v.form.$pending || this.$v.form.$error) return;
                let form = this.form
                form.loading = true
                this.$axios.post(process.env.BACKEND_API+'/user/lawyer/signup', {
                    "email": form.email.val,
                    "password": form.password.val,
                    profileType: 0
                }).then(results => {
                    form.email.valid = true
                    form.password.valid = true
                    form.success = true;
                    form.sent = true;
                    form.loading = false
                    Vue.notify({
                        group: 'foo',
                        type: 'success',
                        title: 'Sign up',
                        text: 'Successfully signed up!'
                    })
                    this.login()
                }).catch(error => {
                    form.loading = false
                    form.success = false;
                    form.sent = true;
                    Vue.notify({
                        group: 'foo',
                        type: 'error',
                        title: 'Error',
                        text: typeof error.response.data == 'string' ? error.response.data : 'Something went wrong!'
                    })
                    let errors = error.response.data.errors
                    if ("email" in errors) {
                        form.email.valid = false
                        form.email.msg = errors.email.message
                    }
                    if ("password" in errors) {
                        form.password.valid = false
                        form.password.msg = errors.password.message
                    }
                })
            },
            login() {
                let form = this.form
                form.loading = true
                let self = this
                try {
                    this.$auth.loginWith('local', {
                        data: {
                            email: form.email.val,
                            password: form.password.val
                        }
                    })
                    form.email.valid = true
                    form.password.valid = true
                    form.success = true;
                    form.sent = true;
                    form.loading = false
                    Vue.notify({
                        group: 'foo',
                        type: 'success',
                        title: 'Sign in',
                        text: 'Successfully signed in!'
                    })
                } catch (e) {
                    Vue.notify({
                        group: 'foo',
                        type: 'error',
                        title: 'Error',
                        text: 'Something went wrong!'
                    })
                    console.log(e)
                    this.error = e.response
                    form.loading = false
                }
            },
        }
    }
</script>
<style>
    body {
        height: 100%;
    }
    .section-lg {
        height: 100vh;
    }
</style>